/* display.m generated from display.pswm
   by unix pswrap V1.009  Wed Apr 19 17:50:24 PDT 1989
 */

#include <dpsclient/dpsfriends.h>
#include <string.h>

#line 1 "display.pswm"
/*
 * Copyright 1990, John G. Myers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* -*- Mode: c -*- */

#import <stdlib.h>
#import <libc.h>
#import <appkit/Application.h>
#import <appkit/Pasteboard.h>
#import <appkit/publicWraps.h>
#import "EtermView.h"

#define TRANSPARENCYBUG /* 2.0 doesn't do transparency in windows correctly */

#define NORMAL 0
#define PREFIX 1
#define SECOND_PREFIX 2
#define ESCAPE 3
#define STRING 4
#define STRING_FUNCTION 5
#define Ctl(a) ((a) & 0x1f)

#ifdef NORMAL
#define FOREGRAY 0
#define BACKGRAY 1
#else
#define FOREGRAY 1
#define BACKGRAY 0
#endif

static id pasteboard;

struct display {
    EtermView *view;
    int cursor_x, cursor_y;
    int state;
    int insert_mode, standout_mode;
    int prefix, second_prefix;
    char *string_buffer;
    int string_buffer_len;
    int string_char;
};

/*
 * Create the information necessary for handling a new display.
 * The return value is the "rock" that should be given to
 * DPSAddFD() as the value to give to input_from_emacs()
 *
 * (A "rock" is the CMU term for an item you hide information
 * underneath.)
 */
void *new_display_rock(EtermView *view)
{
    struct display *new_display;

    new_display = malloc(sizeof(struct display));
    if (!new_display) {
	fprintf(stderr, "Emacs: Virtual memory exhausted\n");
	exit(1);
    }

    new_display->view = view;
    new_display->cursor_x = new_display->cursor_y = 0;
    new_display->state = NORMAL;
    new_display->prefix = new_display->second_prefix = 0;
    new_display->string_buffer_len = 1024;
    new_display->string_buffer = malloc(1024);
    if (!new_display->string_buffer) {
	fprintf(stderr, "Emacs: Virtual memory exhausted\n");
	exit(1);
    }
    new_display->string_char = 0;

    return (void *)new_display;
}
#line 100 "display.m"
static void setup( void )
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjReal obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjReal obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 16, 132,
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_highgray */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0.6666},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_lowgray */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0.3333},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* emacs:fixedfont */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 149},	/* setfont */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[6] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_foregray",
	(char *) 0 ,
	"eichin_highgray",
	"eichin_lowgray",
	"eichin_backgray",
	"emacs:fixedfont"};
    long int *_dps_nameVals[6];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];
    _dps_nameVals[2] = &_dpsCodes[2];
    _dps_nameVals[3] = &_dpsCodes[3];
    _dps_nameVals[4] = &_dpsCodes[4];
    _dps_nameVals[5] = &_dpsCodes[5];

    DPSMapNames(_dpsCurCtxt, 6, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[12].val.nameVal = _dpsCodes[1];
  _dpsP[3].val.nameVal = _dpsCodes[2];
  _dpsP[6].val.nameVal = _dpsCodes[3];
  _dpsP[9].val.nameVal = _dpsCodes[4];
  _dpsP[14].val.nameVal = _dpsCodes[5];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,132);
}
#line 99 "display.pswm"

#line 181 "display.m"
void flip_color( void )
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 12, 100,
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_highgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_lowgray */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_lowgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_highgray */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[8] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_foregray",
	(char *) 0 ,
	"eichin_backgray",
	(char *) 0 ,
	"eichin_highgray",
	(char *) 0 ,
	"eichin_lowgray",
	(char *) 0 };
    long int *_dps_nameVals[8];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];
    _dps_nameVals[2] = &_dpsCodes[2];
    _dps_nameVals[3] = &_dpsCodes[3];
    _dps_nameVals[4] = &_dpsCodes[4];
    _dps_nameVals[5] = &_dpsCodes[5];
    _dps_nameVals[6] = &_dpsCodes[6];
    _dps_nameVals[7] = &_dpsCodes[7];

    DPSMapNames(_dpsCurCtxt, 8, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[7].val.nameVal = _dpsCodes[1];
  _dpsP[1].val.nameVal = _dpsCodes[2];
  _dpsP[6].val.nameVal = _dpsCodes[3];
  _dpsP[2].val.nameVal = _dpsCodes[4];
  _dpsP[5].val.nameVal = _dpsCodes[5];
  _dpsP[3].val.nameVal = _dpsCodes[6];
  _dpsP[4].val.nameVal = _dpsCodes[7];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,100);
}
#line 111 "display.pswm"


#ifdef TRANSPARENCYBUG
#define white_rect(x, y, w, h) clear_rect(x, y, w, h)
#line 263 "display.m"
static void clear_rect(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 9, 76,
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 128},	/* rectfill */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_backgray",
	"eichin_foregray"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.integerVal = x;
  _dpsP[3].val.integerVal = y;
  _dpsP[4].val.integerVal = w;
  _dpsP[5].val.integerVal = h;
  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[7].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,76);
}
#line 120 "display.pswm"

#line 322 "display.m"
static void grey_rect(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 9, 76,
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_lowgray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 128},	/* rectfill */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_lowgray",
	"eichin_foregray"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.integerVal = x;
  _dpsP[3].val.integerVal = y;
  _dpsP[4].val.integerVal = w;
  _dpsP[5].val.integerVal = h;
  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[7].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,76);
}
#line 126 "display.pswm"

#line 381 "display.m"
static void show_cursor(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 6, 52,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* Highlight */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* compositerect */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"Highlight",
	"compositerect"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  _dpsP[2].val.integerVal = w;
  _dpsP[3].val.integerVal = h;
  _dpsP[4].val.nameVal = _dpsCodes[0];
  _dpsP[5].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,52);
}
#line 134 "display.pswm"


#else /* TRANSPARENCYBUG */
#line 436 "display.m"
static void white_rect(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 9, 76,
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 128},	/* rectfill */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_foregray */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_backgray",
	"eichin_foregray"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.integerVal = x;
  _dpsP[3].val.integerVal = y;
  _dpsP[4].val.integerVal = w;
  _dpsP[5].val.integerVal = h;
  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[7].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,76);
}
#line 142 "display.pswm"

#line 495 "display.m"
static void clear_rect(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 6, 52,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* Clear */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* compositerect */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"Clear",
	"compositerect"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  _dpsP[2].val.integerVal = w;
  _dpsP[3].val.integerVal = h;
  _dpsP[4].val.nameVal = _dpsCodes[0];
  _dpsP[5].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,52);
}
#line 146 "display.pswm"

#line 548 "display.m"
static void grey_rect(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 9, 76,
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_highgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* setalpha */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 128},	/* rectfill */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* eichin_backgray */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* setalpha */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[4] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"eichin_highgray",
	"setalpha",
	(char *) 0 ,
	"eichin_backgray"};
    long int *_dps_nameVals[4];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];
    _dps_nameVals[2] = &_dpsCodes[2];
    _dps_nameVals[3] = &_dpsCodes[3];

    DPSMapNames(_dpsCurCtxt, 4, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.integerVal = x;
  _dpsP[3].val.integerVal = y;
  _dpsP[4].val.integerVal = w;
  _dpsP[5].val.integerVal = h;
  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[1].val.nameVal = _dpsCodes[1];
  _dpsP[8].val.nameVal = _dpsCodes[2];
  _dpsP[7].val.nameVal = _dpsCodes[3];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,76);
}
#line 152 "display.pswm"

#line 613 "display.m"
static void show_cursor(int x, int y, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 6, 52,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* Xor */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* compositerect */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"Xor",
	"compositerect"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  _dpsP[2].val.integerVal = w;
  _dpsP[3].val.integerVal = h;
  _dpsP[4].val.nameVal = _dpsCodes[0];
  _dpsP[5].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,52);
}
#line 156 "display.pswm"


#endif /* TRANSPARENCY_BUG */
#line 668 "display.m"
static void copy_rect(int sx, int sy, int dx, int dy, int w, int h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 9, 76,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: sx */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: sy */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 79},	/* gstate */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: dx */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: dy */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* Copy */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* composite */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[2] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"Copy",
	"composite"};
    long int *_dps_nameVals[2];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];

    DPSMapNames(_dpsCurCtxt, 2, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = sx;
  _dpsP[1].val.integerVal = sy;
  _dpsP[5].val.integerVal = dx;
  _dpsP[6].val.integerVal = dy;
  _dpsP[2].val.integerVal = w;
  _dpsP[3].val.integerVal = h;
  _dpsP[7].val.nameVal = _dpsCodes[0];
  _dpsP[8].val.nameVal = _dpsCodes[1];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,76);
}
#line 162 "display.pswm"

#line 729 "display.m"
static void draw_string(int x, int y, char s[], int n)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 5, 44,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 107},	/* moveto */
    {DPS_LITERAL|DPS_STRING, 0, 0, 40},	/* param s */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 160},	/* show */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  register int _dps_offset = 40;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  _dpsP[3].length = n;
  _dpsP[3].val.stringVal = _dps_offset;
  _dps_offset += (n + 3) & ~3;

  _dpsF.nBytes = _dps_offset+4;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,44);
  DPSWriteStringChars(_dpsCurCtxt, (char *)s, n);
  DPSWriteStringChars(_dpsCurCtxt, (char *)_dpsCurCtxt, ~(n + 3) & 3);
}
#line 167 "display.pswm"

#line 770 "display.m"
void obscure_cursor( void )
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 1, 12,
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* obscurecursor */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[1] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"obscurecursor"};
    long int *_dps_nameVals[1];
    _dps_nameVals[0] = &_dpsCodes[0];

    DPSMapNames(_dpsCurCtxt, 1, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.nameVal = _dpsCodes[0];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,12);
}
#line 171 "display.pswm"

#line 806 "display.m"
void fix_font(int width)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    DPSBinObjGeneric obj16;
    DPSBinObjGeneric obj17;
    DPSBinObjGeneric obj18;
    DPSBinObjGeneric obj19;
    DPSBinObjGeneric obj20;
    DPSBinObjGeneric obj21;
    DPSBinObjGeneric obj22;
    DPSBinObjGeneric obj23;
    DPSBinObjGeneric obj24;
    DPSBinObjGeneric obj25;
    DPSBinObjGeneric obj26;
    DPSBinObjGeneric obj27;
    DPSBinObjGeneric obj28;
    DPSBinObjGeneric obj29;
    DPSBinObjGeneric obj30;
    DPSBinObjGeneric obj31;
    DPSBinObjGeneric obj32;
    DPSBinObjGeneric obj33;
    DPSBinObjGeneric obj34;
    DPSBinObjGeneric obj35;
    DPSBinObjGeneric obj36;
    DPSBinObjGeneric obj37;
    DPSBinObjGeneric obj38;
    DPSBinObjGeneric obj39;
    DPSBinObjGeneric obj40;
    DPSBinObjGeneric obj41;
    DPSBinObjGeneric obj42;
    DPSBinObjGeneric obj43;
    DPSBinObjGeneric obj44;
    DPSBinObjGeneric obj45;
    DPSBinObjGeneric obj46;
    DPSBinObjGeneric obj47;
    DPSBinObjGeneric obj48;
    DPSBinObjGeneric obj49;
    DPSBinObjGeneric obj50;
    DPSBinObjGeneric obj51;
    DPSBinObjGeneric obj52;
    DPSBinObjGeneric obj53;
    DPSBinObjGeneric obj54;
    DPSBinObjGeneric obj55;
    DPSBinObjGeneric obj56;
    DPSBinObjGeneric obj57;
    DPSBinObjGeneric obj58;
    DPSBinObjGeneric obj59;
    DPSBinObjGeneric obj60;
    DPSBinObjGeneric obj61;
    DPSBinObjGeneric obj62;
    DPSBinObjGeneric obj63;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 44, 516,
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 32},	/* currentfont */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 56},	/* dup */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 56},	/* dup */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 56},	/* dup */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* FontMatrix */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 75},	/* get */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 75},	/* get */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 54},	/* div */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: width */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* newwidth */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 98},	/* length */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 53},	/* dict */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* newfntdict */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_ARRAY, 0, 7, 400},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 73},	/* forall */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* CharStrings */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 75},	/* get */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 56},	/* dup */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 98},	/* length */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 53},	/* dict */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_ARRAY, 0, 6, 352},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 73},	/* forall */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* newfntdict */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* Metrics */
    {DPS_LITERAL|DPS_INT, 0, 0, 3},
    {DPS_LITERAL|DPS_INT, 0, 0, -1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 135},	/* roll */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 120},	/* put */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* emacs:fixedfont */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* fixedfont */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* newfntdict */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 290},	/* definefont */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 117},	/* pop */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 88},	/* index */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* newwidth */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 120},	/* put */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 88},	/* index */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* FID */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 109},	/* ne */
    {DPS_EXEC|DPS_ARRAY, 0, 5, 472},
    {DPS_EXEC|DPS_ARRAY, 0, 2, 456},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 85},	/* ifelse */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 117},	/* pop */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 117},	/* pop */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* newfntdict */
    {DPS_LITERAL|DPS_INT, 0, 0, 3},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 135},	/* roll */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 120},	/* put */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[12] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"FontMatrix",
	"newwidth",
	(char *) 0 ,
	"newfntdict",
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 ,
	"CharStrings",
	"Metrics",
	"emacs:fixedfont",
	"fixedfont",
	"FID"};
    long int *_dps_nameVals[12];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];
    _dps_nameVals[2] = &_dpsCodes[2];
    _dps_nameVals[3] = &_dpsCodes[3];
    _dps_nameVals[4] = &_dpsCodes[4];
    _dps_nameVals[5] = &_dpsCodes[5];
    _dps_nameVals[6] = &_dpsCodes[6];
    _dps_nameVals[7] = &_dpsCodes[7];
    _dps_nameVals[8] = &_dpsCodes[8];
    _dps_nameVals[9] = &_dpsCodes[9];
    _dps_nameVals[10] = &_dpsCodes[10];
    _dps_nameVals[11] = &_dpsCodes[11];

    DPSMapNames(_dpsCurCtxt, 12, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[11].val.integerVal = width;
  _dpsP[4].val.nameVal = _dpsCodes[0];
  _dpsP[13].val.nameVal = _dpsCodes[1];
  _dpsP[48].val.nameVal = _dpsCodes[2];
  _dpsP[20].val.nameVal = _dpsCodes[3];
  _dpsP[59].val.nameVal = _dpsCodes[4];
  _dpsP[41].val.nameVal = _dpsCodes[5];
  _dpsP[33].val.nameVal = _dpsCodes[6];
  _dpsP[25].val.nameVal = _dpsCodes[7];
  _dpsP[34].val.nameVal = _dpsCodes[8];
  _dpsP[39].val.nameVal = _dpsCodes[9];
  _dpsP[40].val.nameVal = _dpsCodes[10];
  _dpsP[52].val.nameVal = _dpsCodes[11];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,516);
}
#line 188 "display.pswm"

#line 1002 "display.m"
void set_font( void )
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 3, 28,
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* emacs:fixedfont */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 32},	/* currentfont */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[1] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"emacs:fixedfont"};
    long int *_dps_nameVals[1];
    _dps_nameVals[0] = &_dpsCodes[0];

    DPSMapNames(_dpsCurCtxt, 1, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.nameVal = _dpsCodes[0];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,28);
}
#line 192 "display.pswm"


static void invalid()
{
#ifdef DEBUG
    abort();
#endif
}

#define POS_X(a) (SIZE_X (a) + BORDER_WIDTH)
#define POS_Y(a) (SIZE_Y (a) + BORDER_WIDTH)
#define SIZE_X(a) ((int) ((a) * fontWidth))
#define SIZE_Y(a) ((int) ((a) * fontHeight))

void input_from_emacs(int fd, void *rock)
{
    struct display *display = (struct display *)rock;
    int screen_x, screen_y;
    int fontHeight, fontWidth;
    int fontDescender;
    char buf[1024+1];
    int n;
    register char c;
    EtermView *view = display->view;
    int cursor_x = display->cursor_x, cursor_y = display->cursor_y;
    int state = display->state;
    int insert_mode = display->insert_mode;
    int standout_mode = display->standout_mode;
    int prefix = display->prefix, second_prefix = display->second_prefix;
    int string_buffer_len = display->string_buffer_len;
    int string_char = display->string_char;
    int x;


    n = read(fd, buf, sizeof(buf)-1);
    if (n < 1) {
	[NXApp terminate:nil];
    }

    [view lockFocus];
    [view getDimensions:&screen_y :&screen_x];
    [view getDisplayFont:&fontHeight :&fontWidth :&fontDescender];

    setup();

    /* Remove old cursor */
    show_cursor(POS_X(cursor_x), POS_Y(cursor_y), fontWidth, fontHeight);

    for (x = 0; x < n; x++) {
	if ((c = buf[x]) == '\0' && state != STRING)
	  continue;
	switch (state) {
	case NORMAL:
	    if (c >= ' ') {	/* so we print deletes. big deal. */
		int start = x;
		int count;
		int do_newline;

		while (++x < n && buf[x] >= ' ');

		while (count = x - start) {
		    if (do_newline = (count + cursor_x >= screen_x)) {
			count = screen_x - cursor_x;
		    }

		    if (insert_mode) {
			copy_rect(POS_X (cursor_x), POS_Y (cursor_y),
				  POS_X (cursor_x + count), POS_Y (cursor_y),
				  SIZE_X (screen_x - cursor_x - count),
				  SIZE_Y (1));
		    }
		    clear_rect(POS_X (cursor_x), POS_Y (cursor_y),
			       SIZE_X (count), SIZE_Y (1));

		    if (standout_mode)
		      grey_rect(POS_X (cursor_x), POS_Y (cursor_y),
				SIZE_X (count), SIZE_Y (1));

		    draw_string(POS_X (cursor_x),
				POS_Y (cursor_y+1) - (int) fontDescender,
				&buf[start], count);

		    start += count;
		    if (do_newline) {
			cursor_x = 0;
			cursor_y++;
		    }
		    else {
			cursor_x += count;
		    }
		}
		--x;
		break;
	    }
	    switch (c) {
	    case Ctl('a'):
	    case Ctl('m'):	/* Emacs outputs a '\r' on exiting --jgm */
	      cursor_x = 0;
	      break;
	    case Ctl('b'):
	      if (cursor_x > 0)
		--cursor_x;
	      break;
#if 0
	    case Ctl('c'):
	      do_paste (0);
	      break;
	    case Ctl('e'):
	      if (EventChannel != -1) transmitting_events = TRUE;
	      break;
#endif
	    case Ctl('f'):
	      if (++cursor_x >= screen_x)
		cursor_x = 0;
	      break;
	    case Ctl('g'):
	      NXBeep();
	      break;
#if 0
	    case Ctl('h'):
	      if (cursor_x > 0)
		{
		  --cursor_x;
		  delete_chars (1);
		}
	      break;
#endif
	    case Ctl('i'):
	      insert_mode = !insert_mode;
	      break;
	    case Ctl('j'):
	      cursor_x = 0;
	      cursor_y++;
	      break;
	    case Ctl('k'):
	      /* clear_to_end_of_line (); */
	      clear_rect (POS_X (cursor_x), POS_Y (cursor_y),
			  SIZE_X (screen_x - cursor_x), SIZE_Y (1));
	      break;
#if 0
	    case Ctl('l'):
	      do_redraw ();
	      break;
#endif
	    case Ctl('n'):
	      if (cursor_y < screen_y)
		cursor_y++;
	      break;
	    case Ctl('p'):
	      if (cursor_y > 0)
		--cursor_y;
	      break;
	    case Ctl('q'):
	      state = STRING;
	      string_char = 0;
	      break;
	    case Ctl('s'):
	      standout_mode = !standout_mode;
	      break;
	    case Ctl('u'):
	      prefix = 0;
	      state = PREFIX;
	      break;
#if 0
	    case Ctl('y'):
	      wm_GiveupInputFocus();
	      break;
#endif
#if 0
	    case Ctl('z'):
	      [NXApp hide:view];
	      break;
#endif
	    case Ctl('['):
	      state = ESCAPE;
	      break;
	    case Ctl('t'):
	      /* not implemented yet */
	      /* besides, no one will ever use it */
	    default:
	      invalid ();
	      break;
	    }
	  break;
	case PREFIX:
	  switch (c)
	    {
	    case '0': case '1': case '2': case '3': case '4':
	    case '5': case '6': case '7': case '8': case '9':
	      prefix = prefix * 10 + c - '0';
	      break;
	    case '-':
	      prefix = -prefix;
	      break;
#if 0
	    case Ctl('a'):
	      transmitting_events = FALSE;
	      close( EventChannel );
	      EventChannel = -1;
	      goto normal_state;
	    case Ctl('c'):
	      do_paste( prefix );
	      goto normal_state;
#endif
	    case Ctl('d'):
	      if (prefix > 0) {
		  /* delete_chars (prefix); */
		  copy_rect (POS_X (cursor_x + prefix), POS_Y (cursor_y),
			      POS_X (cursor_x), POS_Y (cursor_y),
			      SIZE_X (screen_x - cursor_x - 1), SIZE_Y (1));
		  clear_rect (POS_X (screen_x - prefix), POS_Y (cursor_y),
			      SIZE_X (prefix), SIZE_Y (1));
	      }
	      goto normal_state;
#if 0
	    case Ctl('e'):
	      transmitting_events = FALSE;
	      goto normal_state;
#endif
	    case Ctl('k'):
	      if (prefix > 0) {
		  /* delete_lines (prefix); */
		  copy_rect(POS_X (0), POS_Y (cursor_y + prefix),
			    POS_X (0), POS_Y (cursor_y),
			    SIZE_X (screen_x),
			    SIZE_Y (screen_y - cursor_y - prefix));
		  clear_rect(POS_X (0), POS_Y (screen_y - prefix),
			     SIZE_X (screen_x), SIZE_Y (prefix));
	      }
	      goto normal_state;
	    case Ctl('o'):
	      if (prefix > 0) {
		  /* insert_lines (prefix); */
		  copy_rect(POS_X (0), POS_Y (cursor_y),
			    POS_X (0), POS_Y (cursor_y + prefix),
			    SIZE_X (screen_x),
			    SIZE_Y (screen_y - cursor_y - prefix));
		  clear_rect(POS_X (0), POS_Y (cursor_y),
			     SIZE_X (screen_x), SIZE_Y (prefix));
	      }
	      goto normal_state;
	    case Ctl('q'):
	      state = STRING;
	      string_char = 0;
	      break;
	    case Ctl('u'):
	      second_prefix = 0;
	      state = SECOND_PREFIX;
	      break;
	    case '_':
	      /* insert_spaces (prefix); */
	      if (prefix > 0) {
		  copy_rect(POS_X (cursor_x), POS_Y (cursor_y),
			    POS_X (cursor_x + prefix), POS_Y (cursor_y),
			    SIZE_X (screen_x - cursor_x - prefix), SIZE_Y (1));
		  clear_rect(POS_X (cursor_x), POS_Y (cursor_y),
			     SIZE_X (prefix), SIZE_Y (1));
	      }
	      goto normal_state;
	    case '.':
	      cursor_x = prefix < screen_x ? prefix : 0;
	      goto normal_state;
	    default:
	      invalid ();
	    normal_state:
	      state = NORMAL;
	      break;
	    }
	  break;
	case SECOND_PREFIX:
	  switch (c)
	    {
	    case '0': case '1': case '2': case '3': case '4':
	    case '5': case '6': case '7': case '8': case '9':
	      second_prefix = second_prefix * 10 + c - '0';
	      break;
	    case '.':
	      cursor_x = second_prefix < screen_x ? second_prefix : 0;
	      cursor_y = prefix < screen_y ? prefix : 0;
	      state = NORMAL;
	      break;
	    default:
	      invalid ();
	      state = NORMAL;
	      break;
	    }
	  break;
	case ESCAPE:
	  switch (c) {
	  case 'c':
	      /* clear_screen (); */
	      white_rect(0, 0, SIZE_X(screen_x)+2*BORDER_WIDTH,
			 SIZE_Y(screen_y)+2*BORDER_WIDTH);
#ifndef TRANSPARENCYBUG
	      clear_rect(POS_X(0), POS_Y(0),
			 SIZE_X(screen_x), SIZE_Y(screen_y));
#endif
	      cursor_x = cursor_y = 0;
	      insert_mode = standout_mode = 0;
	      break;
	  case 'k':
	      /* clear_to_end_of_screen (); */
	      clear_rect(POS_X (0), POS_Y (cursor_y),
			 SIZE_X (screen_x), SIZE_Y (screen_y - cursor_y));
	      break;
	  default:
	      invalid ();
	      break;
	    }
	  state = NORMAL;
	  break;
	case STRING:
	  if (string_char == string_buffer_len) {
	      string_buffer_len += 1024;
	      display->string_buffer = realloc(display->string_buffer, string_buffer_len);
	      if (!display->string_buffer) {
		  fprintf(stderr, "Emacs: Virtual memory exhausted\n");
		  exit(1);
	      }
	  }
	  if ((display->string_buffer[ string_char++ ] = c) == '\377')
	    state = STRING_FUNCTION;
	  break;
	case STRING_FUNCTION:
	  {
	    display->string_buffer[ --string_char ] = '\0';
	    switch(c)
	      {
	      case 'c':
		if (!pasteboard) pasteboard = [Pasteboard new];
		[pasteboard declareTypes:&NXAsciiPboard num:1 owner:NXApp];
		[pasteboard writeType:NXAsciiPboard
	     		    data:display->string_buffer
			    length:string_char];
		break;
#if 0
	      case 'e':
		write( MasterChannel, display->string_buffer, string_char );
		break;
	      case 'f':
		change_font( display->string_buffer );
		do_redraw ();
		break;
#endif
	      case 't':
		[[view window] setTitle:display->string_buffer];
		break;
#if 0
	      case 'p':
		wm_SetProgramName( display->string_buffer );
		break;
	      case 'm':
		wm_AddMenu( display->string_buffer );
		break;
#endif
	      default:
		invalid();
		break;
	      }
	    state = NORMAL;
	  }
	}
    }

    /* Display cursor */
    show_cursor(POS_X(cursor_x), POS_Y(cursor_y), fontWidth, fontHeight);

    [view unlockFocus];
    display->cursor_x = cursor_x;
    display->cursor_y = cursor_y;
    display->state = state;
    display->insert_mode = insert_mode;
    display->standout_mode = standout_mode;
    display->prefix = prefix;
    display->second_prefix = second_prefix;
    display->string_buffer_len = string_buffer_len;
    display->string_char = string_char;
}

